Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDao.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDao.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDao.cs	(revision 4629)
@@ -58,5 +58,13 @@
                   orderby ar.Job.Priority descending
                   select Convert.ToDto(ar.Job);
-      return query.ToArray();
+      return query;
+    }
+
+    public IEnumerable<DT.Job> GetAvailableJobs(DT.Slave slave) {
+      var query = from j in db.Jobs
+                  where j.JobState == JobState.Waiting && j.CoresNeeded <= slave.FreeCores && j.MemoryNeeded <= slave.FreeMemory
+                  orderby j.Priority descending
+                  select Convert.ToDto(j);
+      return query.Union(GetAvailableParentJobs(slave.Id)).OrderByDescending(x => x.Priority).ToArray();
     }
     #endregion
@@ -217,6 +225,6 @@
     public bool IsUserAuthorizedForJobs(Guid userId, params Guid[] jobIds) {
       var userIds = from job in db.Jobs // this needs to be fast!
-                 where jobIds.Contains(job.JobId)
-                 select job.UserId;
+                    where jobIds.Contains(job.JobId)
+                    select job.UserId;
       return userIds.All(x => x == userId);
     }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Interfaces/IHiveDao.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Interfaces/IHiveDao.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Interfaces/IHiveDao.cs	(revision 4629)
@@ -15,5 +15,5 @@
     void UpdateJob(DT.Job dto);
     void DeleteJob(Guid id);
-    IEnumerable<DT.Job> GetAvailableParentJobs(Guid slaveId);
+    IEnumerable<DT.Job> GetAvailableJobs(DT.Slave slave);
     #endregion
 
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Tools/CreateHiveDatabaseApplication.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Tools/CreateHiveDatabaseApplication.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Tools/CreateHiveDatabaseApplication.cs	(revision 4629)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Services.Hive.DataAccess {
+  [Application("Create Hive Database", "Creates new empty Hive Database.", true)]
+  class CreateHiveDatabaseApplication : ApplicationBase {
+
+    public override void Run() {
+      CreateDataContext<HiveDataContext> contextCreator = new CreateDataContext<HiveDataContext>(ContextFactory<HiveDataContext>.CreateHiveContext);
+      IContextFactory<HiveDataContext> contextFactory = new ContextFactory<HiveDataContext>(contextCreator);
+
+      using (contextFactory.GetContext(false)) {
+        if (contextFactory.CurrentContext.DatabaseExists())
+          contextFactory.CurrentContext.DeleteDatabase();
+        contextFactory.CurrentContext.CreateDatabase();
+      }
+    }
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Tools/cleanHiveDatabase.sql
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Tools/cleanHiveDatabase.sql	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Tools/cleanHiveDatabase.sql	(revision 4629)
@@ -0,0 +1,17 @@
+DELETE FROM [HeuristicLab.Hive].[dbo].AssignedResources
+DELETE FROM [HeuristicLab.Hive].[dbo].RequiredPlugins
+DELETE FROM [HeuristicLab.Hive].[dbo].PluginInfo
+DELETE FROM [HeuristicLab.Hive].[dbo].UptimeStatistics
+DELETE FROM [HeuristicLab.Hive].[dbo].UptimeCalendar
+DELETE FROM [HeuristicLab.Hive].[dbo].SlaveConfig
+DELETE FROM [HeuristicLab.Hive].[dbo].SlaveGroup_Resource
+DELETE FROM [HeuristicLab.Hive].[dbo].[Resource]
+DELETE FROM [HeuristicLab.Hive].[dbo].HiveExperiment
+DELETE FROM [HeuristicLab.Hive].[dbo].Job
+
+/** only jobs & experiments **/
+DELETE FROM [HeuristicLab.Hive].[dbo].AssignedResources
+DELETE FROM [HeuristicLab.Hive].[dbo].RequiredPlugins
+DELETE FROM [HeuristicLab.Hive].[dbo].PluginInfo
+DELETE FROM [HeuristicLab.Hive].[dbo].HiveExperiment
+DELETE FROM [HeuristicLab.Hive].[dbo].Job
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/MergeConfigs.cmd
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/MergeConfigs.cmd	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/MergeConfigs.cmd	(revision 4629)
@@ -1,10 +1,10 @@
-copy "%SolutionDir%HeuristicLab.Hive-3.3.dll.config" "%TargetPath%"
-echo HeuristicLab.Hive-3.3.dll.config copied
+copy "%SolutionDir%HeuristicLab.Hive-3.3.dll.config" "%TargetDir%"
 
-%SolutionDir%ConfigMerger "%SolutionDir%HeuristicLab.Services.Hive\3.3\app.config" "%TargetPath%HeuristicLab.Hive-3.3.dll.config"
-%SolutionDir%ConfigMerger "%SolutionDir%HeuristicLab.Services.Hive.DataAccess\3.3\app.config" "%TargetPath%HeuristicLab.Hive-3.3.dll.config"
+%SolutionDir%ConfigMerger "%SolutionDir%HeuristicLab.Services.Hive\3.3\app.config" "%TargetDir%HeuristicLab.Hive-3.3.dll.config"
+%SolutionDir%ConfigMerger "%SolutionDir%HeuristicLab.Services.Hive.DataAccess\3.3\app.config" "%TargetDir%HeuristicLab.Hive-3.3.dll.config"
 
-copy "%SolutionDir%HeuristicLab-3.3.dll.config" "%TargetPath%"
-echo HeuristicLab-3.3.dll.config copied
+copy "%SolutionDir%HeuristicLab 3.3.exe.config" "%TargetDir%"
 
-%SolutionDir%ConfigMerger "HeuristicLab.Hive-3.3.dll.config" "HeuristicLab 3.3.exe.config"
+%SolutionDir%ConfigMerger "%SolutionDir%HeuristicLab.Hive-3.3.dll.config" "HeuristicLab 3.3.exe.config"
+
+copy "HeuristicLab 3.3.exe.config" "%target%"
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Calendar/3.3/Properties/AssemblyInfo.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Calendar/3.3/Properties/AssemblyInfo.cs	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Calendar/3.3/Properties/AssemblyInfo.cs	(revision 4629)
@@ -58,3 +58,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.0.4560")]
+[assembly: AssemblyFileVersion("3.3.0.4598")]
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln	(revision 4629)
@@ -81,4 +81,24 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Hive.Slave.ExecutionEngine-3.3", "HeuristicLab.Hive.Slave.ExecutionEngine\3.3\HeuristicLab.Hive.Slave.ExecutionEngine-3.3.csproj", "{1605256A-1CB3-44AB-AAFF-577093EE5789}"
+EndProject
+Project("{E24C65DC-7377-472B-9ABA-BC803B73C61A}") = "HiveWeb", "..\..\..\..\..\Web\HiveWeb\", "{F8E2A0BB-5B04-49EE-88CE-F0DF12474221}"
+	ProjectSection(WebsiteProperties) = preProject
+		TargetFrameworkMoniker = ".NETFramework,Version%3Dv4.0"
+		Debug.AspNetCompiler.VirtualPath = "/HiveWeb"
+		Debug.AspNetCompiler.PhysicalPath = "..\..\..\..\..\Web\HiveWeb\"
+		Debug.AspNetCompiler.TargetPath = "PrecompiledWeb\HiveWeb\"
+		Debug.AspNetCompiler.Updateable = "true"
+		Debug.AspNetCompiler.ForceOverwrite = "true"
+		Debug.AspNetCompiler.FixedNames = "false"
+		Debug.AspNetCompiler.Debug = "True"
+		Release.AspNetCompiler.VirtualPath = "/HiveWeb"
+		Release.AspNetCompiler.PhysicalPath = "..\..\..\..\..\Web\HiveWeb\"
+		Release.AspNetCompiler.TargetPath = "PrecompiledWeb\HiveWeb\"
+		Release.AspNetCompiler.Updateable = "true"
+		Release.AspNetCompiler.ForceOverwrite = "true"
+		Release.AspNetCompiler.FixedNames = "false"
+		Release.AspNetCompiler.Debug = "False"
+		VWDPort = "2681"
+	EndProjectSection
 EndProject
 Global
@@ -372,4 +392,16 @@
 		{1605256A-1CB3-44AB-AAFF-577093EE5789}.Release|x86.ActiveCfg = Release|x86
 		{1605256A-1CB3-44AB-AAFF-577093EE5789}.Release|x86.Build.0 = Release|x86
+		{F8E2A0BB-5B04-49EE-88CE-F0DF12474221}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{F8E2A0BB-5B04-49EE-88CE-F0DF12474221}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{F8E2A0BB-5B04-49EE-88CE-F0DF12474221}.Debug|Mixed Platforms.ActiveCfg = Debug|Any CPU
+		{F8E2A0BB-5B04-49EE-88CE-F0DF12474221}.Debug|Mixed Platforms.Build.0 = Debug|Any CPU
+		{F8E2A0BB-5B04-49EE-88CE-F0DF12474221}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{F8E2A0BB-5B04-49EE-88CE-F0DF12474221}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{F8E2A0BB-5B04-49EE-88CE-F0DF12474221}.Release|Any CPU.ActiveCfg = Debug|Any CPU
+		{F8E2A0BB-5B04-49EE-88CE-F0DF12474221}.Release|Any CPU.Build.0 = Debug|Any CPU
+		{F8E2A0BB-5B04-49EE-88CE-F0DF12474221}.Release|Mixed Platforms.ActiveCfg = Debug|Any CPU
+		{F8E2A0BB-5B04-49EE-88CE-F0DF12474221}.Release|Mixed Platforms.Build.0 = Debug|Any CPU
+		{F8E2A0BB-5B04-49EE-88CE-F0DF12474221}.Release|x64.ActiveCfg = Debug|Any CPU
+		{F8E2A0BB-5B04-49EE-88CE-F0DF12474221}.Release|x86.ActiveCfg = Debug|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj	(revision 4624)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj	(revision 4629)
@@ -192,3 +192,7 @@
 call PreBuildEvent.cmd</PreBuildEvent>
   </PropertyGroup>
+  <PropertyGroup>
+    <PostBuildEvent>
+    </PostBuildEvent>
+  </PropertyGroup>
 </Project>
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HiveWeb/App_Code/HiveServerModule.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HiveWeb/App_Code/HiveServerModule.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HiveWeb/App_Code/HiveServerModule.cs	(revision 4629)
@@ -0,0 +1,41 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Web;
+using System.Threading;
+using HeuristicLab.Tracing;
+using System.IO;
+
+namespace HeuristicLab.Hive.Server.Core.IISModules {
+  public class HiveServerModule : IHttpModule {
+    Thread t;
+
+    #region IHttpModule Members
+
+    public void Dispose() {
+      if (t != null && t.ThreadState == ThreadState.Running) {
+        t.Abort();
+      }
+      File.Create(@"C:\ch\stuff\Log\Dispose" + Thread.CurrentThread.ManagedThreadId).Dispose();
+    }
+
+    public void Init(HttpApplication context) {
+
+      File.Create(@"C:\ch\stuff\Log\Init." + Thread.CurrentThread.ManagedThreadId).Dispose();
+      t = new Thread(DoSomething);
+      t.Start();
+    }
+
+    private void DoSomething() {
+      int i = 0;
+      while (true) {
+        Thread.Sleep(1000);
+        File.Create(@"C:\ch\stuff\Log\file" + Thread.CurrentThread.ManagedThreadId + "." + i).Dispose();
+        i++;
+      }
+    }
+
+    #endregion
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HiveWeb/ClientService.svc
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HiveWeb/ClientService.svc	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HiveWeb/ClientService.svc	(revision 4629)
@@ -0,0 +1,5 @@
+﻿<%@ ServiceHost 
+  Language="C#" 
+  Debug="true" 
+  Service="HeuristicLab.Hive.Server.Core.ClientFacade" 
+  %>
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HiveWeb/ServerConsoleService.svc
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HiveWeb/ServerConsoleService.svc	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HiveWeb/ServerConsoleService.svc	(revision 4629)
@@ -0,0 +1,5 @@
+﻿<%@ ServiceHost 
+  Language="C#" 
+  Debug="true" 
+  Service="HeuristicLab.Hive.Server.Core.ServerConsoleFacade" 
+  %>
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HiveWeb/SlaveService.svc
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HiveWeb/SlaveService.svc	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HiveWeb/SlaveService.svc	(revision 4629)
@@ -0,0 +1,5 @@
+﻿<%@ ServiceHost 
+  Language="C#" 
+  Debug="true" 
+  Service="HeuristicLab.Hive.Server.Core.SlaveFacade" 
+  %>
